#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=BlackTube.ico
#AutoIt3Wrapper_outfile=BlackTube.exe
#AutoIt3Wrapper_UseX64=n

#AutoIt3Wrapper_Res_Description=BlackTube Downloader
#AutoIt3Wrapper_Res_Field=BlackTube
#AutoIt3Wrapper_Res_Productversion=1.0.195.0
#AutoIt3Wrapper_Res_Fileversion=1.0.195.0
#AutoIt3Wrapper_Res_LegalCopyright=Copyright  2012 NETGATE Technologies s.r.o.

#AutoIt3Wrapper_Add_Constants=n
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiStatusBar.au3>
#include <ComboConstants.au3>
#include <Date.au3>

#include "YouTube.au3"


;---- Settings ---
Global $VERSION = "31" ;3.0
Global $LOG = False ; enable writing logs to ]
Global $SCRIPT_TITLE = "BlackTube Downloader"
Global $TEMP_PATH = @TempDir & "\BlackTubeDownloader"
Global $UPDATE_URL = "http://www.netgate.sk/download/update_bt.php?version=30"

; Global controls
Global $mainGUI
Global $progress
Global $lblProgress
Global $statusBar

                    

#Region ----------------BEGIN GUI -----------------------------
$mainGUI = GUICreate($SCRIPT_TITLE, 556, 340, 330, 176); 550, 200, 236, 160)
$statusBar = _GUICtrlStatusBar_Create($mainGUI)

; ------------- MAIN TAB ------------------
$mainTab = GUICtrlCreateTab(0, 0, 553, 305, 0) ;0, 0, 553, 209)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

;first tab-------
$TabSheet1 = GUICtrlCreateTabItem("Download as Audio (MP3)")
$icon = GUICtrlCreateIcon("BlackTube.ico", 2, 2, 40, 128, 128)
$inputLink = GUICtrlCreateInput("", 185, 89, 265, 21)
$cmdDownload = GUICtrlCreateButton("Download", 458, 87, 75, 25, $WS_GROUP)
$progress = GUICtrlCreateProgress(209, 235, 310, 24)
GUICtrlSetData(-1, 40)
$Label2 = GUICtrlCreateLabel("Video Link:", 130, 93, 54, 17)
$Label2a = GUICtrlCreateLabel("Example: http://www.youtube.com/watch?v=XXXXXXX", 130, 124, 270, 17)
$lblProgress = GUICtrlCreateLabel("Downloading...0%", 104, 240, 95, 17)


;_GDIPlus_StartUp()
;$hImage  = _GDIPlus_ImageLoadFromFile( @ScriptDir & "\steps.png")
;$hGraphic = _GDIPlus_GraphicsCreateFromHWND($mainGUI)
;_GDIPlus_GraphicsDrawImage($hGraphic, $hImage, 20, 50)



;second tab-------
$TabSheet2 = GUICtrlCreateTabItem("Download as Video (AVI)")
$icon_AVI = GUICtrlCreateIcon("BlackTube.ico", 2, 2, 40, 128, 128)
$inputLink_AVI = GUICtrlCreateInput("", 185, 89, 265, 21)
$cmdDownload_AVI = GUICtrlCreateButton("Download", 458, 87, 75, 25, $WS_GROUP)
$progress_AVI = GUICtrlCreateProgress(209, 235, 310, 24)
GUICtrlSetData(-1, 40)
$Label2_AVI = GUICtrlCreateLabel("Video Link:", 130, 93, 54, 17)
$Label2a_AVI = GUICtrlCreateLabel("Example: http://www.youtube.com/watch?v=XXXXXXX", 130, 124, 270, 17)

$Combo2_AVI = GUICtrlCreateCombo("Maximum Resolution", 304, 150, 145, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "720x576|640x480|320x240", "Maximum Resolution")

$lblProgress_AVI = GUICtrlCreateLabel("Downloading...0%", 104, 240, 95, 17)


;third tab-------
$TabSheet3 = GUICtrlCreateTabItem("About BlackTube Downloader")
$icon = GUICtrlCreateIcon("BlackTube.ico", 2, 2, 40, 128, 128)

$aboutlbl = GUICtrlCreateLabel("BlackTube Downloader v. 1.0.195" & @CRLF & "Copyright (C) 2012 NETGATE Technologies s.r.o." & @CRLF & "Licensed under the terms of the GNU GPL version 3.", 200, 43, 250, 50)
$websitelbl = GUICtrlCreateLabel('http://www.netgate.sk/products/blacktube/', 200, 100, 250, 17)

;$cmdCheckUpdate = GUICtrlCreateButton("Check for updates", 239, 73, 100, 25)

GUICtrlSetFont($websitelbl, 8.5, 400, 4)
GUICtrlSetColor($websitelbl, 0x0000FF)


;hide some controls for now
;set progress to 0 and set show to false to hide
progress(0, False)
progressAVI(0, False)

GUISetState(@SW_SHOW)
#Region ----------------END GUI -----------------------------

; Clean up before exiting
OnAutoItExitRegister("cleanExit")
setup()
mainLoop()

Func mainLoop()
	While 1
		$msg = GUIGetMsg()

		;if $msg == $cmdCheckUpdate Then checkForUpdates()
		If $msg == $websitelbl Then ShellExecute("http://www.netgate.sk/products/blacktube/")
		If $msg == $GUI_EVENT_CLOSE Then Exit
		If $msg == $cmdDownload Then initialize()
		if $msg == $cmdDownload_AVI Then initializeAVI()
	WEnd
EndFunc   ;==>mainLoop

Func setup()
	If Not FileExists(@ScriptDir & "\ffmpeg.exe") Then
		alert("FFmpeg not found. Exiting.", 16)
		Exit
	EndIf
	DirCreate($TEMP_PATH)
EndFunc   ;==>setup



Func initialize()
	; Get the text input from the input control
	$userInput = GUICtrlRead($inputLink)
	
	$userInput = StringReplace($userInput,"feature=endscreen&NR=1&","")
  $userInput = StringReplace($userInput,"feature=endscreen&","")

	;Cancel download if the user supplied an invalid YouTube link
	If Not _YTCheckFormat($userInput) Then
		alert("Invalid YouTube link detected.", 16)
		_trace("User supplied an invalid YouTube link. Canceling download operation.")
		Return False
	EndIf

	;get a valid download link from YouTube source
	_trace("Attempting to get download link...", True)
	$download_link = _YTGetDownloadLink($userInput)

	;get video metadata
	_trace("Getting video metadata", True)
	$video_info = _YTGetVideoInformation($userInput)

  _trace("Getting video metadata, done", True)


	Local $video_title = "Audio1"
	
	If IsArray( $video_info ) Then
     $video_title = $video_info[0]
  EndIf


	;Get output path. This is used for ffmpeg conversion, not download!
	$path = savePath($video_title)

	; Cancel the operation if the user cancels save dialog
	If Not $path Then
		cancel()
	EndIf
	_trace("File output set to: " & $path, True)

	;Download the video in a temporary path defined above
	_trace("Downloading video...", True)

	;Disable download button
	GUICtrlSetState($cmdDownload, $GUI_DISABLE)

	$result = downloadVideo($download_link, $TEMP_PATH & "\temp")
	if NOT $result Then
		alert("Unable to download video. Check your link and try again.")
		mainLoop()
	EndIf

	_trace("Download complete!", True)

	;Convert the video
	_trace("Converting video...", True)
	$result = convertVideo($TEMP_PATH & "\temp", $path)

	If NOT ($result) Then
  	GUICtrlSetState($cmdDownload, $GUI_ENABLE)
		alert("Error converting video. Check log for details.", 16)
		_trace("Done.", True)
		cancel()
	Else
  	GUICtrlSetState($cmdDownload, $GUI_ENABLE)
		alert("Video converted successfully. File saved to: " & $path & ".", 64)
		_trace("Done.", True)
		mainLoop()
	EndIf


	;
EndFunc   ;==>initialize
 
Func initializeAVI()
	; Get the text input from the input control
	$userInput = GUICtrlRead($inputLink_AVI)

	$userInput = StringReplace($userInput,"feature=endscreen&NR=1&","")
	$userInput = StringReplace($userInput,"feature=endscreen&","")

	;Cancel download if the user supplied an invalid YouTube link
	If Not _YTCheckFormat($userInput) Then
		alert("Invalid YouTube link detected.", 16)
		_trace("User supplied an invalid YouTube link. Canceling download operation.")
		Return False
	EndIf

	;get a valid download link from YouTube source
	_trace("Attempting to get download link...", True)
	$download_link = _YTGetDownloadLink($userInput)

	;get video metadata
	_trace("Getting video metadata", True)
	$video_info = _YTGetVideoInformation($userInput)

	Local $video_title = "Video1"
	
	If IsArray( $video_info ) Then
     $video_title = $video_info[0]
  EndIf


	;Get output path. This is used for ffmpeg conversion, not download!
	$path = savePathAVI($video_title)

	; Cancel the operation if the user cancels save dialog
	If Not $path Then
		cancel()
	EndIf
	_trace("File output set to: " & $path, True)

	;Download the video in a temporary path defined above
	_trace("Downloading video...", True)

	;Disable download button
	GUICtrlSetState($cmdDownload_AVI, $GUI_DISABLE)

	$result = downloadVideoAVI($download_link, $TEMP_PATH & "\temp")
	if NOT $result Then
		alert("Unable to download video. Check your link and try again.")
		mainLoop()
	EndIf

	_trace("Download complete!", True)

	;Convert the video
	_trace("Converting video...", True)
	$result = convertVideoAVI($TEMP_PATH & "\temp", $path)

	If NOT ($result) Then
  	GUICtrlSetState($cmdDownload_AVI, $GUI_ENABLE)
		alert("Error converting video. Check log for details.", 16)
		_trace("Done.", True)
		cancel()
	Else
  	GUICtrlSetState($cmdDownload_AVI, $GUI_ENABLE)
		alert("Video converted successfully. File saved to: " & $path & ".", 64)
		_trace("Done.", True)
		mainLoop()
	EndIf


	;
EndFunc   ;==>initialize 


Func downloadVideo($url, $downloadPath)
	$dHwnd = InetGet($url, $downloadPath, 1, 1)

	$percent = 0
	While $percent <= 99
		$dInfo = InetGetInfo($dHwnd, -1)
		if @error Then
		_trace("downloadVideo(): InetGetInfo() set @errror!")
		progress(0,False)
		InetClose($dHwnd)
		return False
	EndIf
		$percent = Floor($dInfo[0] / $dInfo[1] * 100)
		
		If $percent < 0 Then
		  $percent = 0
    EndIf

		; Set progress bar
		progress($percent, True)
		; Set label
		Sleep(1000)
	WEnd
	;reset and hide progress controls
	InetClose($dHwnd)
	progress(0, False)
	return True
EndFunc   ;==>downloadVideo


Func downloadVideoAVI($url, $downloadPath)
	$dHwnd = InetGet($url, $downloadPath, 1, 1)

	$percent = 0
	While $percent <= 99
		$dInfo = InetGetInfo($dHwnd, -1)
		if @error Then
		_trace("downloadVideoAVI(): InetGetInfo() set @errror!")
		progressAVI(0,False)
		InetClose($dHwnd)
		return False
	EndIf
		$percent = Floor($dInfo[0] / $dInfo[1] * 100)

		If $percent < 0 Then
		  $percent = 0
    EndIf

		; Set progress bar
		progressAVI($percent, True)
		; Set label
		Sleep(1000)
	WEnd
	;reset and hide progress controls
	InetClose($dHwnd)
	progressAVI(0, False)
	return True
EndFunc   ;==>downloadVideoAVI



Func convertVideo($file, $savePath)
	;TODO - put settings in a var
	_trace("convertVideo(): attempting to convert input file. Settings: -y, -ab192k")

  Local $line, $fulltime, $lastreturn
  Local $PID = Run(@ScriptDir & "\ffmpeg.exe" & ' -i "' & $file & '" -y -ab 192k' & ' "' & $savePath & '"', @WorkingDir, @SW_HIDE, 0x08)
  While 1
    $line &= StdoutRead($PID)
    If @error Then ExitLoop

    If Not $fulltime Then
        $return = StringRegExp($line,"Duration: (\d{2}):(\d{2}):(\d{2})",1)
        If IsArray($return) Then
            $fulltime = $return[0]*3600 + $return[1]*60 + $return[2]
        EndIf
    EndIf

    $array = StringSplit($line,@CRLF)

    $return = StringRegExp($array[$array[0]-1],"time=(\d{2}):(\d{2}):(\d{2})",1)
    If @error Then ContinueLoop

    $actualtime = $return[0]*3600 + $return[1]*60 + $return[2]

    If $actualtime <> $lastreturn Then
        $lastreturn = Number($actualtime)
        progress( Int(($lastreturn/$fulltime)*100), True, True )
    EndIf
  WEnd
  
  progress( 0, False )

  If FileExists($savePath) Then
		_trace("convertVideo(): Output file found! Conversion assumed to be successful.")
		Return True
	Else
		_trace("convertVideo(): Output file not found! Conversion assumed to be a failure.")
		Return False
	EndIf
EndFunc   ;==>convertVideo


Func convertVideoAVI($file, $savePath)
	;TODO - put settings in a var
	_trace("convertVideo(): attempting to convert input file. Settings: -y -sameq -vcodec libxvid -ab 192k")

  $resolution = GUICtrlRead($Combo2_AVI)

  Local $line, $fulltime, $lastreturn
  Local $PID

  If $resolution <> "Maximum Resolution" Then
      $PID = Run(@ScriptDir & "\ffmpeg.exe" & ' -i "' & $file & '" -y -sameq -vcodec libxvid -ab 192k -s ' & $resolution & ' "' & $savePath & '"', @WorkingDir, @SW_HIDE, 0x08)
  Else
      $PID = Run(@ScriptDir & "\ffmpeg.exe" & ' -i "' & $file & '" -y -sameq -vcodec libxvid -ab 192k' & ' "' & $savePath & '"', @WorkingDir, @SW_HIDE, 0x08)
  EndIf
  

  While 1
    $line &= StdoutRead($PID)
    If @error Then ExitLoop

    If Not $fulltime Then
        $return = StringRegExp($line,"Duration: (\d{2}):(\d{2}):(\d{2})",1)
        If IsArray($return) Then
            $fulltime = $return[0]*3600 + $return[1]*60 + $return[2]
        EndIf
    EndIf

    $array = StringSplit($line,@CRLF)

    $return = StringRegExp($array[$array[0]-1],"time=(\d{2}):(\d{2}):(\d{2})",1)
    If @error Then ContinueLoop

    $actualtime = $return[0]*3600 + $return[1]*60 + $return[2]

    If $actualtime <> $lastreturn Then
        $lastreturn = Number($actualtime)
        progressAVI( Int(($lastreturn/$fulltime)*100), True, True )
    EndIf
  WEnd
  
  progressAVI( 0, False )


  If FileExists($savePath) Then
		_trace("convertVideo(): Output file found! Conversion assumed to be successful.")
		Return True
	Else
		_trace("convertVideo(): Output file not found! Conversion assumed to be a failure.")
		Return False
	EndIf
EndFunc   ;==>convertVideo 

Func progress($percent, $show = True, $conv = False)
	If Not $show Then
		GUICtrlSetState($progress, $GUI_HIDE)
		GUICtrlSetState($lblProgress, $GUI_HIDE)
	Else
		GUICtrlSetState($progress, $GUI_SHOW)
		GUICtrlSetState($lblProgress, $GUI_SHOW)
	EndIf
	
  If Not $conv Then
   	GUICtrlSetData($lblProgress, "Downloading..." & $percent & "%")
  Else
   	GUICtrlSetData($lblProgress, "Converting..." & $percent & "%")
  EndIf

	GUICtrlSetData($progress, $percent)
EndFunc   ;==>progress
 
Func progressAVI($percent, $show = True, $conv = False)
	If Not $show Then
		GUICtrlSetState($progress_AVI, $GUI_HIDE)
		GUICtrlSetState($lblProgress_AVI, $GUI_HIDE)
	Else
		GUICtrlSetState($progress_AVI, $GUI_SHOW)
		GUICtrlSetState($lblProgress_AVI, $GUI_SHOW)
	EndIf

  If Not $conv Then
   	GUICtrlSetData($lblProgress_AVI, "Downloading..." & $percent & "%")
  Else
   	GUICtrlSetData($lblProgress_AVI, "Converting..." & $percent & "%")
  EndIf

	GUICtrlSetData($progress_AVI, $percent)
EndFunc   ;==>progress 


Func alert($message, $code = 16)
	MsgBox($code, $SCRIPT_TITLE, $message, 0, $mainGUI)
EndFunc   ;==>alert

Func savePath($filename)
	$path = FileSaveDialog("Save MP3 as...", @DesktopDir, "mp3 (*.mp3)", 16, $filename)
	If Not @error Then
		; append mp3 extension if not set
		If StringRight($path, 4) <> ".mp3" Then
			$path = $path & ".mp3"
		EndIf
		Return $path
	Else
		Return False
	EndIf
EndFunc   ;==>savePath
 
Func savePathAVI($filename)
	$path = FileSaveDialog("Save AVI as...", @DesktopDir, "avi (*.avi)", 16, $filename)
	If Not @error Then
		; append avi extension if not set
		If StringRight($path, 4) <> ".avi" Then
			$path = $path & ".avi"
		EndIf
		Return $path
	Else
		Return False
	EndIf
EndFunc   ;==>savePath

Func cleanExit()
	; remove temporarily downloaded files
	DirRemove($TEMP_PATH)
	
	Exit
EndFunc   ;==>cleanExit

Func cancel()
	alert("The operation was cancelled.", 16)
	status("")
	mainLoop()
EndFunc   ;==>cancel


Func status($val)
	_GUICtrlStatusBar_SetText($statusBar, $val)
EndFunc   ;==>status

Func _trace($value, $printToStatus = False)
	If $printToStatus Then status($value)
	Local $out = "[ " & @HOUR & ":" & @MIN & ":" & @SEC & "." & @MSEC & " ] -- " & $value & @CRLF
	ConsoleWrite($out)
	If $LOG Then FileWriteLine(@ScriptDir & "\BlackTube.log", $out)
EndFunc   ;==>_trace



; This function simply checks if there's a new version out
; Future updates will allow automatic updates to the next version
Func checkForUpdates()
	_trace("checkForUpdates(): Contacting update server...")
	_trace("checkForUpdates(): Update url set to " & $UPDATE_URL)
	InetGet($UPDATE_URL,$TEMP_PATH&"\update.txt",1)
	$updateRequired = FileRead($TEMP_PATH&"\update.txt")
	; something is wrong with the server side script on sourceforge
	if @error Then
		_trace("checkForUpdates(): failed to communicate with update server on SourceForge")
		alert("Unable to contact update server.")
	elseif $updateRequired == "true" Then
		alert("There is a new version available!",64)
	Elseif $updateRequired == "false" Then
		alert("You have the latest version.",64)
	EndIf
	_trace("Update server returned: " & $updateRequired)
EndFunc

